; File: HOOKINT.ASM

; Author: Matthew Mastracci

; Purpose: Implements the low-level INT8 handler.

[BITS 32]

%include "general.inc"

[GLOBAL _TickHandler__Fv]
[GLOBAL _TickHandler__Size]
[EXTERN _Timer1]
[EXTERN _Timer2]
[EXTERN _Flag1]
[EXTERN _Flag2]
[EXTERN _TickCount]

[SECTION .text ALIGN=4]

align
_TickHandler__Fv:
        inc dword [_TickCount]
        dec dword [_Timer1]
        dec dword [_Timer2]
        cmp dword [_Timer1], 0
        jz .SetFlag1
        jmp .TestFlag2
.SetFlag1:
        mov dword [_Flag1], 1
.TestFlag2:
        cmp dword [_Timer2], 0
        jz .SetFlag2
        jmp .Done
.SetFlag2:
        mov dword [_Flag2], 1
.Done:
        ret

_TickHandler__Size      dd      $-_TickHandler__Fv

[SECTION .data]

